#!/usr/bin/env python
# coding: utf-8

# In[4]:


import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import json
import itkdb
import time

def hybrid_assembly_interface():
    #global variables from function access

    #global variables from function access
    db_password1 = None
    db_password2 = None
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Hybrid Flex Panel Registration', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    #####Password verification
    
    
    label_pw = tk.Label(app, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=40, justify='left', bg='yellow') 
    label_pw.pack(padx = 10, pady = 10)
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(row=1, column=1)
    entry_pw1 = tk.Entry(frame_pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(row=1, column=2)


    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(row=2, column=1)
    entry_pw2 = tk.Entry(frame_pw1)
    entry_pw2['show'] = '*'
    entry_pw2.grid(row=2, column=2)




    def pw_read():
        global db_password1, db_password2, client
        db_password1 = entry_pw1.get()
        db_password2 = entry_pw2.get()
        if db_password1 and db_password2 :
            box.showinfo( 'Confirmation', 'Received Passwords' )
            try:
                u = itkdb.core.User(accessCode1=db_password1, accessCode2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                box.showinfo( 'Success', 'Hello {} {}, \nwelcome to the ITk database'                             .format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                entry_pw1.delete(0,'end')
                entry_pw2.delete(0,'end')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 


    button = tk.Button(app, text='Get Password', width=25, command = pw_read, bg='yellow' )
    button.pack(padx = 10, pady = 10)
    
    
    
    label_subsection = tk.Label(app, text='Hybrid Assembly', bg='deepskyblue', fg='black', font=('Arial Black', 10))
    label_subsection.pack(padx = 10, pady = 10)
    
    
       
    
    
    
    #hybrid test panel name
    frame_panel = tk.Frame(app)
    frame_panel.pack(padx = 10, pady = 10)
    panelLabel = tk.Label(frame_panel, text='Hybrid Test Panel ATLAS ID: ', width = 25 )
    panelLabel.grid(row=1, column=1)
    panelName = tk.StringVar()
    testPanelName = tk.Entry(frame_panel, textvariable = panelName, width = 30)
    testPanelName.grid(row=1, column=2)
    label_panel_example = tk.Label(frame_panel, text='ATLAS ID, e.g. 20USBHP1234567')
    label_panel_example.grid(sticky="w", row=2, column=2)
    
    #position on panel
    frame_panelPos = tk.Frame(app)
    frame_panelPos.pack()
    panelPosLabel = tk.Label(frame_panelPos, text='Hybrid Position on Panel: ', width = 20)
    panelPosLabel.grid(row=1, column=1)
    hybrid_panel_position = ttk.Combobox(frame_panelPos, width=5)
    hybrid_panel_position['values'] = ('0', '1', '2', '3', '4', '5')
    hybrid_panel_position.grid(row=1, column=2)
    
    #used tools
    frame_panelTools = tk.Frame(app)
    frame_panelTools.pack()
    panelJigLabel = tk.Label(frame_panelTools, text='Panel Jig: ', width=15)
    panelJigLabel.grid(row=1, column=1)
    panelJig = tk.StringVar()
    panelJigName = tk.Entry(frame_panelTools, textvariable=panelJig, width=30)
    panelJigName.grid(row=1, column=2)
    panelPickUpLabel = tk.Label(frame_panelTools, text='PickUp Tool: ', width=15)
    panelPickUpLabel.grid(row=2, column=1)
    panelPickUp = tk.StringVar()
    panelPickUpName = tk.Entry(frame_panelTools, textvariable=panelPickUp, width=30)
    panelPickUpName.grid(row=2, column=2)
    
    
    
#############not in V1###############    
    #hybrid assembly name
    frame_assembly = tk.Frame(app)
    frame_assembly.pack(padx = 10, pady = 10)
    assemblyLabel = tk.Label(frame_assembly, text='Hybrid Assembly alternative ID: ', width = 25 )
    assemblyLabel.grid(row=1, column=1)
    assemblyName = tk.StringVar()
    hybridAssemblyName = tk.Entry(frame_assembly, textvariable = assemblyName, width = 30)
    hybridAssemblyName.grid(row=1, column=2)
    label_assembly_example = tk.Label(frame_assembly, text='Altnernative ID, e.g. LIV-X-0012')
    label_assembly_example.grid(sticky="w", row=2, column=2)
    
    #position on panel (string, list 0 to 5)
    frame_assembly2 = tk.Frame(app)
    frame_assembly2.pack()
    hybridType = tk.Label(frame_assembly2, text='Hybrid Type', width = 10)
    hybridType.grid(row=3, column=1)
    hybrid_type = tk.StringVar()
    radio_X = tk.Radiobutton (frame_assembly2, text='X', variable=hybrid_type, value= 'X' )
    radio_Y = tk.Radiobutton (frame_assembly2, text='Y', variable=hybrid_type, value= 'Y')
    radio_X.select()
    assemblyName.set('LIV-X-')
    radio_X.grid(row=3, column=2)
    radio_Y.grid(row=3, column=3)
    
    
###############################    
    
    
    
    #hybrid flex name
    frame_flex = tk.Frame(app)
    frame_flex.pack(padx = 10, pady = 10)
    flexLabel = tk.Label(frame_flex, text='Hybrid Flex ID: ', width = 15 )
    flexLabel.grid(row=1, column=1)
    flexName = tk.StringVar()
    hybridFlexName = tk.Entry(frame_flex, textvariable = flexName, width = 30)
    hybridFlexName.grid(row=1, column=2)
    label_flex_example = tk.Label(frame_flex, text='Format: <Batch>_<type>_<number>_<letter>_<hybrid>')
    label_flex_example.grid(sticky="w",row=2, column=2)
    label_flex_example2 = tk.Label(frame_flex, text='e.g.: GPC1919_X_003_A_H2')
    label_flex_example2.grid(sticky="w",row=3, column=2)
    

    
    
    #input for ASICs
    frame_asics = tk.Frame(app)
    frame_asics.pack(padx = 10, pady = 10)
    
    header_chip_id = tk.Label(frame_asics, text='Chip Position', width=10, bg='grey')
    header_chip_id.grid(row=0, column=1)
    header_chip_db_id = tk.Label(frame_asics, text='Chip DB ID', width=17, bg='grey')
    header_chip_db_id.grid(row=0, column=2)
    header_chip_wafer = tk.Label(frame_asics, text='Chip Wafer', width=15, bg='grey')
    header_chip_wafer.grid(row=0, column=3)
    header_chip_position = tk.Label(frame_asics, text='Position on Wafer', width=15, bg='grey')
    header_chip_position.grid(row=0, column=4)
    
    hcc_id = tk.StringVar()
    hcc_id.set('HCC_X_0')
    hcc_label = tk.Label (frame_asics, textvariable=hcc_id, width=10, bg='silver')
    hcc_label.grid(row=1, column=1)
    hcc_db_id = tk.StringVar()
    hcc_db_id_entry = tk.Entry(frame_asics, textvariable=hcc_db_id, width=17)
    hcc_db_id_entry.grid(row=1, column=2)
    hcc_wafer = tk.StringVar()
    hcc_wafer_entry = tk.Entry(frame_asics, textvariable=hcc_wafer, width=15)
    hcc_wafer_entry.grid(row=1, column=3)
    hcc_wafer_position = tk.StringVar()
    hcc_wafer_pos_entry = tk.Entry(frame_asics, textvariable=hcc_wafer_position, width=15)
    hcc_wafer_pos_entry.grid(row=1, column=4)
    
    abc0_id = tk.StringVar()
    abc0_id.set('ABC_X_9')
    abc0_label = tk.Label (frame_asics, textvariable=abc0_id, width=10, bg='silver')
    abc0_label.grid(row=2, column=1)
    abc0_db_id = tk.StringVar()
    abc0_db_id_entry = tk.Entry(frame_asics, textvariable=abc0_db_id, width=17)
    abc0_db_id_entry.grid(row=2, column=2)
    abc0_wafer = tk.StringVar()
    abc0_wafer_entry = tk.Entry(frame_asics, textvariable=abc0_wafer, width=15)
    abc0_wafer_entry.grid(row=2, column=3)
    abc0_wafer_position = tk.StringVar()
    abc0_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc0_wafer_position, width=15)
    abc0_wafer_pos_entry.grid(row=2, column=4)
    
    
    abc1_id = tk.StringVar()
    abc1_id.set('ABC_X_8')
    abc1_label = tk.Label (frame_asics, textvariable=abc1_id, width=10, bg='silver')
    abc1_label.grid(row=3, column=1)
    abc1_db_id = tk.StringVar()
    abc1_db_id_entry = tk.Entry(frame_asics, textvariable=abc1_db_id, width=17)
    abc1_db_id_entry.grid(row=3, column=2)
    abc1_wafer = tk.StringVar()
    abc1_wafer_entry = tk.Entry(frame_asics, textvariable=abc1_wafer, width=15)
    abc1_wafer_entry.grid(row=3, column=3)
    abc1_wafer_position = tk.StringVar()
    abc1_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc1_wafer_position, width=15)
    abc1_wafer_pos_entry.grid(row=3, column=4)
    
    abc2_id = tk.StringVar()
    abc2_id.set('ABC_X_7')
    abc2_label = tk.Label (frame_asics, textvariable=abc2_id, width=10, bg='silver')
    abc2_label.grid(row=4, column=1)
    abc2_db_id = tk.StringVar()
    abc2_db_id_entry = tk.Entry(frame_asics, textvariable=abc2_db_id, width=17)
    abc2_db_id_entry.grid(row=4, column=2)
    abc2_wafer = tk.StringVar()
    abc2_wafer_entry = tk.Entry(frame_asics, textvariable=abc2_wafer, width=15)
    abc2_wafer_entry.grid(row=4, column=3)
    abc2_wafer_position = tk.StringVar()
    abc2_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc2_wafer_position, width=15)
    abc2_wafer_pos_entry.grid(row=4, column=4)
    
    abc3_id = tk.StringVar()
    abc3_id.set('ABC_X_6')
    abc3_label = tk.Label (frame_asics, textvariable=abc3_id, width=10, bg='silver')
    abc3_label.grid(row=5, column=1)
    abc3_db_id = tk.StringVar()
    abc3_db_id_entry = tk.Entry(frame_asics, textvariable=abc3_db_id, width=17)
    abc3_db_id_entry.grid(row=5, column=2)
    abc3_wafer = tk.StringVar()
    abc3_wafer_entry = tk.Entry(frame_asics, textvariable=abc3_wafer, width=15)
    abc3_wafer_entry.grid(row=5, column=3)
    abc3_wafer_position = tk.StringVar()
    abc3_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc3_wafer_position, width=15)
    abc3_wafer_pos_entry.grid(row=5, column=4)
    
    abc4_id = tk.StringVar()
    abc4_id.set('ABC_X_5')
    abc4_label = tk.Label (frame_asics, textvariable=abc4_id, width=10, bg='silver')
    abc4_label.grid(row=6, column=1)
    abc4_db_id = tk.StringVar()
    abc4_db_id_entry = tk.Entry(frame_asics, textvariable=abc4_db_id, width=17)
    abc4_db_id_entry.grid(row=6, column=2)
    abc4_wafer = tk.StringVar()
    abc4_wafer_entry = tk.Entry(frame_asics, textvariable=abc4_wafer, width=15)
    abc4_wafer_entry.grid(row=6, column=3)
    abc4_wafer_position = tk.StringVar()
    abc4_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc4_wafer_position, width=15)
    abc4_wafer_pos_entry.grid(row=6, column=4)
    
    abc5_id = tk.StringVar()
    abc5_id.set('ABC_X_4')
    abc5_label = tk.Label (frame_asics, textvariable=abc5_id, width=10, bg='silver')
    abc5_label.grid(row=7, column=1)
    abc5_db_id = tk.StringVar()
    abc5_db_id_entry = tk.Entry(frame_asics, textvariable=abc5_db_id, width=17)
    abc5_db_id_entry.grid(row=7, column=2)
    abc5_wafer = tk.StringVar()
    abc5_wafer_entry = tk.Entry(frame_asics, textvariable=abc5_wafer, width=15)
    abc5_wafer_entry.grid(row=7, column=3)
    abc5_wafer_position = tk.StringVar()
    abc5_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc5_wafer_position, width=15)
    abc5_wafer_pos_entry.grid(row=7, column=4)
    
    abc6_id = tk.StringVar()
    abc6_id.set('ABC_X_3')
    abc6_label = tk.Label (frame_asics, textvariable=abc6_id, width=10, bg='silver')
    abc6_label.grid(row=8, column=1)
    abc6_db_id = tk.StringVar()
    abc6_db_id_entry = tk.Entry(frame_asics, textvariable=abc6_db_id, width=17)
    abc6_db_id_entry.grid(row=8, column=2)
    abc6_wafer = tk.StringVar()
    abc6_wafer_entry = tk.Entry(frame_asics, textvariable=abc6_wafer, width=15)
    abc6_wafer_entry.grid(row=8, column=3)
    abc6_wafer_position = tk.StringVar()
    abc6_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc6_wafer_position, width=15)
    abc6_wafer_pos_entry.grid(row=8, column=4)
    
    abc7_id = tk.StringVar()
    abc7_id.set('ABC_X_2')
    abc7_label = tk.Label (frame_asics, textvariable=abc7_id, width=10, bg='silver')
    abc7_label.grid(row=9, column=1)
    abc7_db_id = tk.StringVar()
    abc7_db_id_entry = tk.Entry(frame_asics, textvariable=abc7_db_id, width=17)
    abc7_db_id_entry.grid(row=9, column=2)
    abc7_wafer = tk.StringVar()
    abc7_wafer_entry = tk.Entry(frame_asics, textvariable=abc7_wafer, width=15)
    abc7_wafer_entry.grid(row=9, column=3)
    abc7_wafer_position = tk.StringVar()
    abc7_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc7_wafer_position, width=15)
    abc7_wafer_pos_entry.grid(row=9, column=4)
    
    abc8_id = tk.StringVar()
    abc8_id.set('ABC_X_1')
    abc8_label = tk.Label (frame_asics, textvariable=abc8_id, width=10, bg='silver')
    abc8_label.grid(row=10, column=1)
    abc8_db_id = tk.StringVar()
    abc8_db_id_entry = tk.Entry(frame_asics, textvariable=abc8_db_id, width=17)
    abc8_db_id_entry.grid(row=10, column=2)
    abc8_wafer = tk.StringVar()
    abc8_wafer_entry = tk.Entry(frame_asics, textvariable=abc8_wafer, width=15)
    abc8_wafer_entry.grid(row=10, column=3)
    abc8_wafer_position = tk.StringVar()
    abc8_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc8_wafer_position, width=15)
    abc8_wafer_pos_entry.grid(row=10, column=4)
    
    abc9_id = tk.StringVar()
    abc9_id.set('ABC_X_0')
    abc9_label = tk.Label (frame_asics, textvariable=abc9_id, width=10, bg='silver')
    abc9_label.grid(row=11, column=1)
    abc9_db_id = tk.StringVar()
    abc9_db_id_entry = tk.Entry(frame_asics, textvariable=abc9_db_id, width=17)
    abc9_db_id_entry.grid(row=11, column=2)
    abc9_wafer = tk.StringVar()
    abc9_wafer_entry = tk.Entry(frame_asics, textvariable=abc9_wafer, width=15)
    abc9_wafer_entry.grid(row=11, column=3)
    abc9_wafer_position = tk.StringVar()
    abc9_wafer_pos_entry = tk.Entry(frame_asics, textvariable=abc9_wafer_position, width=15)
    abc9_wafer_pos_entry.grid(row=11, column=4)
    
    
    
    
    
    
    def type_trace(self, *args):
        #print( hybrid_type.get() )
        if hybrid_type.get()=='X':
            hcc_id.set('HCC_X_0')
            abc0_id.set('ABC_X_9')
            abc1_id.set('ABC_X_8')
            abc2_id.set('ABC_X_7')
            abc3_id.set('ABC_X_6')
            abc4_id.set('ABC_X_5')
            abc5_id.set('ABC_X_4')
            abc6_id.set('ABC_X_3')
            abc7_id.set('ABC_X_2')
            abc8_id.set('ABC_X_1')
            abc9_id.set('ABC_X_0')
            assemblyName.set('LIV-X-')
        elif hybrid_type.get()=='Y':
            hcc_id.set('HCC_Y_0')
            abc0_id.set('ABC_Y_0')
            abc1_id.set('ABC_Y_1')
            abc2_id.set('ABC_Y_2')
            abc3_id.set('ABC_Y_3')
            abc4_id.set('ABC_Y_4')
            abc5_id.set('ABC_Y_5')
            abc6_id.set('ABC_Y_6')
            abc7_id.set('ABC_Y_7')
            abc8_id.set('ABC_Y_8')
            abc9_id.set('ABC_Y_9')
            assemblyName.set('LIV-Y-')
        hybridFlexName.delete(0,'end')
        
        
    hybrid_type.trace('w', type_trace)
    
    
    
    ##standard process (difference only in step 1)
    #1) create hybrid assembly
    #1.1) output ATLAS ID and alternative ID
    #2) assemble hybrid assembly to panel
    #3) assemble flex to hybrid assembly
    #3.1) disassmble flex from array
    #3.2) assemble to hybrid assembly
    #4) assemble ASICs to hybrid assembly
    #4.1) maybe check if ASICs are assembled to gel-pack and then disassemble
    
    
    
    
    
    
    
    
      ####current process
    #1) get hybrid assembly name
    #  1.1) output ATLAS ID and alternative ID
    #2) assemble hybrid assembly to panel
    #3) assemble flex to hybrid assembly
    #  3.1) disassmble flex from array
    #  3.2) assemble to hybrid assembly
    #4) assemble ASICs to hybrid assembly

    
    def create_assembly():
        global db_password1, db_password2, client
        if not client:
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        if not hcc_db_id_entry.get() or not abc0_db_id_entry.get()                 or not abc1_db_id_entry.get()                 or not abc2_db_id_entry.get()                 or not abc3_db_id_entry.get()                 or not abc4_db_id_entry.get()                 or not abc5_db_id_entry.get()                 or not abc6_db_id_entry.get()                 or not abc7_db_id_entry.get()                 or not abc8_db_id_entry.get()                 or not abc9_db_id_entry.get():
            print('Please enter all Chip database IDs')
            return
        if not hybrid_panel_position.get():
            print('Hybrid Position on Panel required.')
            return
        if not panelJigName.get() or not panelPickUpName.get():
            print('Used tools are required')
            return
        
        
        
        #automatic set wafer position value
        if hcc_wafer_pos_entry.get() == "":
            hcc_wafer_position.set( hcc_db_id_entry.get()[-3:] )
        if abc0_wafer_pos_entry.get() == "":
            abc0_wafer_position.set( abc0_db_id_entry.get()[-3:] )
        if abc1_wafer_pos_entry.get() == "":
            abc1_wafer_position.set( abc1_db_id_entry.get()[-3:] )
        if abc2_wafer_pos_entry.get() == "":
            abc2_wafer_position.set( abc2_db_id_entry.get()[-3:] )
        if abc3_wafer_pos_entry.get() == "":
            abc3_wafer_position.set( abc3_db_id_entry.get()[-3:] )
        if abc4_wafer_pos_entry.get() == "":
            abc4_wafer_position.set( abc4_db_id_entry.get()[-3:] )
        if abc5_wafer_pos_entry.get() == "":
            abc5_wafer_position.set( abc5_db_id_entry.get()[-3:] )
        if abc6_wafer_pos_entry.get() == "":
            abc6_wafer_position.set( abc6_db_id_entry.get()[-3:] )
        if abc7_wafer_pos_entry.get() == "":
            abc7_wafer_position.set( abc7_db_id_entry.get()[-3:] )
        if abc8_wafer_pos_entry.get() == "":
            abc8_wafer_position.set( abc8_db_id_entry.get()[-3:] )
        if abc9_wafer_pos_entry.get() == "":
            abc9_wafer_position.set( abc9_db_id_entry.get()[-3:] )
        
        if hcc_wafer_entry.get() == "":
            hcc_wafer.set("N/A")
        if abc0_wafer_entry.get() == "":
            abc0_wafer.set("N/A")
        if abc1_wafer_entry.get() == "":
            abc1_wafer.set(abc0_wafer_entry.get())
        if abc2_wafer_entry.get() == "":
            abc2_wafer.set(abc0_wafer_entry.get())
        if abc3_wafer_entry.get() == "":
            abc3_wafer.set(abc0_wafer_entry.get())
        if abc4_wafer_entry.get() == "":
            abc4_wafer.set(abc0_wafer_entry.get())
        if abc5_wafer_entry.get() == "":
            abc5_wafer.set(abc0_wafer_entry.get())
        if abc6_wafer_entry.get() == "":
            abc6_wafer.set(abc0_wafer_entry.get())
        if abc7_wafer_entry.get() == "":
            abc7_wafer.set(abc0_wafer_entry.get())
        if abc8_wafer_entry.get() == "":
            abc8_wafer.set(abc0_wafer_entry.get())
        if abc9_wafer_entry.get() == "":
            abc9_wafer.set(abc0_wafer_entry.get())

        
        
        
        
        
        print( '==============================================================')
        print( 'Test Panel Name: ', testPanelName.get().strip() )
        print( 'Hybrid Assembly: ', hybridAssemblyName.get().strip() )
        print( 'Position on Panel: ', hybrid_panel_position.get() )
        print( 'Panel Jig: ', panelJigName.get(), '\tPick-Up Tool: ', panelPickUpName.get())
        print( 'Hybrid Flex: ', hybridFlexName.get().strip() )
        
        
        print( 'HCC: ', hcc_id.get(), ' ', hcc_db_id_entry.get(), ' ', hcc_wafer_entry.get(), ' ', hcc_wafer_pos_entry.get() )
        print( 'ABC0: ', abc0_id.get(), ' ', abc0_db_id_entry.get(), ' ', abc0_wafer_entry.get(), ' ', abc0_wafer_pos_entry.get() )
        
        
        
        
        #get hybrid assembly from database
        db_hybrid_assembly = client.get('getComponent', json={
                "component":hybridAssemblyName.get(),
                "alternativeIdentifier":True 
                })
        print( 'Hybrid Assembly: ', db_hybrid_assembly["serialNumber"], '; ', db_hybrid_assembly["alternativeIdentifier"] )
        
        
        #get hybrid test panel from database
        db_test_panel = client.get('getComponent', json={
                "component":testPanelName.get() 
                })
        print( 'Test Panel: ', db_test_panel["serialNumber"], '; ', db_test_panel["alternativeIdentifier"])
        
        
        #assemble hybrid assembly to test panel
        asm_hybrid_panel = client.post('assembleComponent', json={
            "parent" : db_test_panel["code"],
            "child" : db_hybrid_assembly["code"],
            "properties":{
                "HYBRID_POSITION" : hybrid_panel_position.get(),
                "JIG_FOR_HYBRID_PLACEMENT" : panelJigName.get(),
                "PICKUPTOOL_FOR_HYBRID_PLACEMENT" : panelPickUpName.get()
            }
        })
        print('Hybrid Assembly assembled to Test Panel')
        
        
        #assemble hybrid flex to hybrid assembly
        ##1 disassemble hybrid flex from array
        db_hybrid_flex = client.get('getComponent', json={
                "component":hybridFlexName.get(), 
                "alternativeIdentifier": True 
                })
        db_hybrid_array = client.get('getComponent', json={
                "component":hybridFlexName.get().strip('_0123456789H'), 
                "alternativeIdentifier": True 
                })
        disasm_hybrid_flex = client.post('disassembleComponent', json={ 
            "parent": db_hybrid_array["code"],
            "child": db_hybrid_flex["code"],
            "trashed": False
        })
        print('Hybrid Flex disassembled from Hybrid Array')
        
        ##2 assemble hybrid flex to hybrid assembly
        asm_hybrid_flex = client.post('assembleComponent', json={
            "parent" : db_hybrid_assembly["code"],
            "child" : db_hybrid_flex["code"]
        })
        print('Hybrid Flex assembled to Hybrid Assembly')
        
        
        #assemble ASICs to hybrid assembly
        asm_hcc = client.post('assembleComponent', json={
            "parent" : db_hybrid_assembly["code"],
            "child" : hcc_db_id_entry.get(),
            "properties": {
                "WAFER_NUMBER" : hcc_wafer_entry.get(), 
                "POSITION_ON_WAFER" : int(hcc_wafer_pos_entry.get())
            }
        })
        print('HCC assembled to Hybrid Assembly')
        
        def abc_assembly(abc_name, abc_position, abc_wafer, abc_wafer_position):
            asm_abc = client.post('assembleComponent', json={
                "parent" : db_hybrid_assembly["code"],
                "child" : abc_name,
                "properties": {
                    "ABC_POSITION": abc_position,
                    "WAFER_NUMBER" : abc_wafer, 
                    "POSITION_ON_WAFER" : int(abc_wafer_position)
                }
            })
                                  
        ###abc0
        abc_assembly( abc0_db_id_entry.get(), abc0_id.get(), abc0_wafer_entry.get(), abc0_wafer_pos_entry.get() )
        abc_assembly( abc1_db_id_entry.get(), abc1_id.get(), abc1_wafer_entry.get(), abc1_wafer_pos_entry.get() )
        abc_assembly( abc2_db_id_entry.get(), abc2_id.get(), abc2_wafer_entry.get(), abc2_wafer_pos_entry.get() )
        abc_assembly( abc3_db_id_entry.get(), abc3_id.get(), abc3_wafer_entry.get(), abc3_wafer_pos_entry.get() )
        abc_assembly( abc4_db_id_entry.get(), abc4_id.get(), abc4_wafer_entry.get(), abc4_wafer_pos_entry.get() )
        abc_assembly( abc5_db_id_entry.get(), abc5_id.get(), abc5_wafer_entry.get(), abc5_wafer_pos_entry.get() )
        abc_assembly( abc6_db_id_entry.get(), abc6_id.get(), abc6_wafer_entry.get(), abc6_wafer_pos_entry.get() )
        abc_assembly( abc7_db_id_entry.get(), abc7_id.get(), abc7_wafer_entry.get(), abc7_wafer_pos_entry.get() )
        abc_assembly( abc8_db_id_entry.get(), abc8_id.get(), abc8_wafer_entry.get(), abc8_wafer_pos_entry.get() )
        abc_assembly( abc9_db_id_entry.get(), abc9_id.get(), abc9_wafer_entry.get(), abc9_wafer_pos_entry.get() )
        print('ABC assembled to Hybrid Assembly')
    
              
        box.showinfo( 'Info', 'Hybrid fully assembled.' )
        
        
        
        
        ##reset all values that might be different
        # hybrid flex name, hcc ID & position, abc id & position,  hybrid assembly id
        
        
        hybrid_panel_position.set('')
        
        hybridFlexName.delete(16,'end')
        hybridAssemblyName.delete(6,'end')
        hcc_db_id_entry.delete(11,'end')
        hcc_wafer_pos_entry.delete(0,'end')
        
        abc0_db_id_entry.delete(11,'end')
        abc0_wafer_pos_entry.delete(0,'end')
        abc1_db_id_entry.delete(11,'end')
        abc1_wafer_pos_entry.delete(0,'end')
        abc2_db_id_entry.delete(11,'end')
        abc2_wafer_pos_entry.delete(0,'end')
        abc3_db_id_entry.delete(11,'end')
        abc3_wafer_pos_entry.delete(0,'end')
        abc4_db_id_entry.delete(11,'end')
        abc4_wafer_pos_entry.delete(0,'end')
        abc5_db_id_entry.delete(11,'end')
        abc5_wafer_pos_entry.delete(0,'end')
        abc6_db_id_entry.delete(11,'end')
        abc6_wafer_pos_entry.delete(0,'end')
        abc7_db_id_entry.delete(11,'end')
        abc7_wafer_pos_entry.delete(0,'end')
        abc8_db_id_entry.delete(11,'end')
        abc8_wafer_pos_entry.delete(0,'end')
        abc9_db_id_entry.delete(11,'end')
        abc9_wafer_pos_entry.delete(0,'end')
    
    
    
    create_button = tk.Button(app, text='Create', width = 20, command = create_assembly )
    create_button.pack(  padx = 10, pady = 10) 
    
    
    
    
    
    
    def clear_abc_wafer():
        abc0_wafer_entry.delete(0,'end')
        abc0_db_id_entry.delete(0,'end')
        abc0_wafer_pos_entry.delete(0,'end')
        abc1_wafer_entry.delete(0,'end')
        abc1_db_id_entry.delete(0,'end')
        abc1_wafer_pos_entry.delete(0,'end')
        abc2_wafer_entry.delete(0,'end')
        abc2_db_id_entry.delete(0,'end')
        abc2_wafer_pos_entry.delete(0,'end')
        abc3_wafer_entry.delete(0,'end')
        abc3_db_id_entry.delete(0,'end')
        abc3_wafer_pos_entry.delete(0,'end')
        abc4_wafer_entry.delete(0,'end')
        abc4_db_id_entry.delete(0,'end')
        abc4_wafer_pos_entry.delete(0,'end')
        abc5_wafer_entry.delete(0,'end')
        abc5_db_id_entry.delete(0,'end')
        abc5_wafer_pos_entry.delete(0,'end')
        abc6_wafer_entry.delete(0,'end')
        abc6_db_id_entry.delete(0,'end')
        abc6_wafer_pos_entry.delete(0,'end')
        abc7_wafer_entry.delete(0,'end')
        abc7_db_id_entry.delete(0,'end')
        abc7_wafer_pos_entry.delete(0,'end')
        abc8_wafer_entry.delete(0,'end')
        abc8_db_id_entry.delete(0,'end')
        abc8_wafer_pos_entry.delete(0,'end')
        abc9_wafer_entry.delete(0,'end')
        abc9_db_id_entry.delete(0,'end')
        abc9_wafer_pos_entry.delete(0,'end')
        print("Wafer cleared")
    
    def clear_hcc_wafer():
        hcc_wafer_entry.delete(0,'end')
        hcc_db_id_entry.delete(0,'end')
        hcc_wafer_pos_entry.delete(0,'end')
    
    
    def clear_all():
        clear_abc_wafer()
        clear_hcc_wafer()
        testPanelName.delete(0,'end')
        hybrid_panel_position.delete(0,'end')
        panelJigName.delete(0,'end')
        panelPickUpName.delete(0,'end')
        hybridAssemblyName.delete(0,'end')
        hybridFlexName.delete(0,'end')
        print("All cleared.")
        
        
    frame_clear = tk.Frame(app)
    frame_clear.pack(padx = 10, pady = 10)    
    
    clear_abc_wafer_button = tk.Button(frame_clear, text='Clear ABC Wafer', width = 20, command = clear_abc_wafer )
    clear_abc_wafer_button.grid(row=0, column=0)
    
    clear_hcc_wafer_button = tk.Button(frame_clear, text='Clear HCC Wafer', width = 20, command = clear_hcc_wafer )
    clear_hcc_wafer_button.grid(row=0, column=1)
    
    clear_all_button = tk.Button(frame_clear, text='Clear All', width = 20, command = clear_all )
    clear_all_button.grid(row=0, column=2)
    
    
    
    
    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed    
    
    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
        
        
    app.mainloop()

    
    
    
    
    
  

  
    
if __name__ == "__main__":
    window = tk.Tk()
    ##window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    
    hybrid_assembly_interface()
    
    


# In[ ]:




